int DI = 12;
int RW = 11;
int DB[] = {3, 4, 5, 6, 7, 8, 9, 10};
int Enable = 2;

void lcd_command_write(int value) {
 // poll all the pins
 int i = 0;
 for (i=DB[0]; i <= DI; i++) {
   digitalWrite(i,value & 01);
   value >>= 1;
 }
 digitalWrite(Enable,LOW);
 delayMicroseconds(1);
 // send a pulse to enable
 digitalWrite(Enable,HIGH);
 delayMicroseconds(1);  // pause 1 ms according to datasheet
 digitalWrite(Enable,LOW);
 delay(1);  // pause 1 ms according to datasheet
}

void lcd_data_write(int value) {
 // poll all the pins
 int i = 0;
 digitalWrite(DI, HIGH);
 digitalWrite(RW, LOW);
 for (i=DB[0]; i <= DB[7]; i++) {
   digitalWrite(i,value & 01);
   value >>= 1;
 }
 digitalWrite(Enable,LOW);
 delayMicroseconds(1);
 // send a pulse to enable
 digitalWrite(Enable,HIGH);
 delayMicroseconds(1);
 digitalWrite(Enable,LOW);
 delay(1);  // pause 1 ms according to datasheet
}

void lcd_write_string(char* str) {
  while (*str != 0) {
    lcd_data_write(*str);
    str++;
  }
}

void lcd_row(int row) {
  switch (row) {
    case 0:
      lcd_command_write(0x80);
      break;
    case 1:
      lcd_command_write(0x80 | 0x40);
      break;
    case 2:
      lcd_command_write(0x80 | 0x14);
      break;
    case 3:
      lcd_command_write(0x80 | (0x40 + 0x14));
      break;
  }
}

void lcd_init() {
  int i = 0;
  for (i=Enable; i <= DI; i++) {
    pinMode(i,OUTPUT);
  }
  delay(100);
  lcd_command_write(0x38); // 8bit, 2 lines, 5x7 font
  delay(64);
  lcd_command_write(0x38); // 8bit, 2 lines, 5x7 font
  delay(50);
  lcd_command_write(0x38); // 8bit, 2 lines, 5x7 font
  delay(20);
  lcd_command_write(0x06); // increment, no shift
  delay(20);
  lcd_command_write(0x0E); // display on, cursor on, no blink
  delay(20);
  lcd_command_write(0x01); // clear, home
  delay(100);
  lcd_row(0);
}

void lcd_clear() {
  lcd_command_write(0x01);
  delay(100);
}

/*void setup(void) {
  lcd_init();
}

void loop (void) {
  lcd_row(0);
  lcd_write_string("this");
  lcd_row(1);
  lcd_write_string("is");
  lcd_row(2);
  lcd_write_string("a");
  lcd_row(3);
  lcd_write_string("test");
  delay(1000);
}*/
